
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.slidesadventuremod.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.world.BiomeLoadingEvent;

import net.minecraft.world.level.levelgen.placement.PlacedFeature;
import net.minecraft.world.level.levelgen.feature.Feature;
import net.minecraft.world.level.levelgen.GenerationStep;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.Holder;

import net.mcreator.slidesadventuremod.world.features.plants.WildPotatoFeature;
import net.mcreator.slidesadventuremod.world.features.plants.SquatCactusFeature;
import net.mcreator.slidesadventuremod.world.features.plants.MarigoldFeature;
import net.mcreator.slidesadventuremod.world.features.plants.LilyturfFeature;
import net.mcreator.slidesadventuremod.world.features.plants.AubrietaFeature;
import net.mcreator.slidesadventuremod.world.features.ores.PricklyPearStage3Feature;
import net.mcreator.slidesadventuremod.world.features.ores.PricklyPearStage2Feature;
import net.mcreator.slidesadventuremod.world.features.ores.PricklyPearStage1Feature;
import net.mcreator.slidesadventuremod.world.features.ores.PricklyPearFruitPlantFeature;
import net.mcreator.slidesadventuremod.world.features.ores.LeafFloorFeature;
import net.mcreator.slidesadventuremod.world.features.ores.FrigidiumOreFeature;
import net.mcreator.slidesadventuremod.world.features.ores.CrackedStoneFeature;
import net.mcreator.slidesadventuremod.world.features.RuinedStructure1Feature;
import net.mcreator.slidesadventuremod.world.features.EnchantedShrineFeature;
import net.mcreator.slidesadventuremod.SlidesAdventureModMod;

import java.util.function.Supplier;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;

@Mod.EventBusSubscriber
public class SlidesAdventureModModFeatures {
	public static final DeferredRegister<Feature<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.FEATURES, SlidesAdventureModMod.MODID);
	private static final List<FeatureRegistration> FEATURE_REGISTRATIONS = new ArrayList<>();
	public static final RegistryObject<Feature<?>> LEAF_FLOOR = register("leaf_floor", LeafFloorFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, LeafFloorFeature.GENERATE_BIOMES, LeafFloorFeature::placedFeature));
	public static final RegistryObject<Feature<?>> RUINED_STRUCTURE_1 = register("ruined_structure_1", RuinedStructure1Feature::feature,
			new FeatureRegistration(GenerationStep.Decoration.SURFACE_STRUCTURES, RuinedStructure1Feature.GENERATE_BIOMES,
					RuinedStructure1Feature::placedFeature));
	public static final RegistryObject<Feature<?>> FRIGIDIUM_ORE = register("frigidium_ore", FrigidiumOreFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.UNDERGROUND_ORES, FrigidiumOreFeature.GENERATE_BIOMES, FrigidiumOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> PRICKLY_PEAR_STAGE_1 = register("prickly_pear_stage_1", PricklyPearStage1Feature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, PricklyPearStage1Feature.GENERATE_BIOMES,
					PricklyPearStage1Feature::placedFeature));
	public static final RegistryObject<Feature<?>> PRICKLY_PEAR_STAGE_2 = register("prickly_pear_stage_2", PricklyPearStage2Feature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, PricklyPearStage2Feature.GENERATE_BIOMES,
					PricklyPearStage2Feature::placedFeature));
	public static final RegistryObject<Feature<?>> PRICKLY_PEAR_STAGE_3 = register("prickly_pear_stage_3", PricklyPearStage3Feature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, PricklyPearStage3Feature.GENERATE_BIOMES,
					PricklyPearStage3Feature::placedFeature));
	public static final RegistryObject<Feature<?>> PRICKLY_PEAR_FRUIT_PLANT = register("prickly_pear_fruit_plant",
			PricklyPearFruitPlantFeature::feature, new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES,
					PricklyPearFruitPlantFeature.GENERATE_BIOMES, PricklyPearFruitPlantFeature::placedFeature));
	public static final RegistryObject<Feature<?>> ENCHANTED_SHRINE = register("enchanted_shrine", EnchantedShrineFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.SURFACE_STRUCTURES, EnchantedShrineFeature.GENERATE_BIOMES,
					EnchantedShrineFeature::placedFeature));
	public static final RegistryObject<Feature<?>> LILYTURF = register("lilyturf", LilyturfFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.VEGETAL_DECORATION, LilyturfFeature.GENERATE_BIOMES, LilyturfFeature::placedFeature));
	public static final RegistryObject<Feature<?>> AUBRIETA = register("aubrieta", AubrietaFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.VEGETAL_DECORATION, AubrietaFeature.GENERATE_BIOMES, AubrietaFeature::placedFeature));
	public static final RegistryObject<Feature<?>> CRACKED_STONE = register("cracked_stone", CrackedStoneFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.UNDERGROUND_ORES, CrackedStoneFeature.GENERATE_BIOMES, CrackedStoneFeature::placedFeature));
	public static final RegistryObject<Feature<?>> MARIGOLD = register("marigold", MarigoldFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.VEGETAL_DECORATION, MarigoldFeature.GENERATE_BIOMES, MarigoldFeature::placedFeature));
	public static final RegistryObject<Feature<?>> SQUAT_CACTUS = register("squat_cactus", SquatCactusFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.VEGETAL_DECORATION, SquatCactusFeature.GENERATE_BIOMES, SquatCactusFeature::placedFeature));
	public static final RegistryObject<Feature<?>> WILD_POTATO = register("wild_potato", WildPotatoFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.VEGETAL_DECORATION, WildPotatoFeature.GENERATE_BIOMES, WildPotatoFeature::placedFeature));

	private static RegistryObject<Feature<?>> register(String registryname, Supplier<Feature<?>> feature, FeatureRegistration featureRegistration) {
		FEATURE_REGISTRATIONS.add(featureRegistration);
		return REGISTRY.register(registryname, feature);
	}

	@SubscribeEvent
	public static void addFeaturesToBiomes(BiomeLoadingEvent event) {
		for (FeatureRegistration registration : FEATURE_REGISTRATIONS) {
			if (registration.biomes() == null || registration.biomes().contains(event.getName()))
				event.getGeneration().getFeatures(registration.stage()).add(registration.placedFeature().get());
		}
	}

	private static record FeatureRegistration(GenerationStep.Decoration stage, Set<ResourceLocation> biomes,
			Supplier<Holder<PlacedFeature>> placedFeature) {
	}
}
