
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.slidesadventuremod.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;

import net.minecraft.world.level.block.Block;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.BlockItem;

import net.mcreator.slidesadventuremod.item.RustyIronArmorItem;
import net.mcreator.slidesadventuremod.item.PricklyPearSeedItem;
import net.mcreator.slidesadventuremod.item.PricklyPearItem;
import net.mcreator.slidesadventuremod.item.PricklyPearCactusItem;
import net.mcreator.slidesadventuremod.item.ObsidianSwordItem;
import net.mcreator.slidesadventuremod.item.FrigidsteelItem;
import net.mcreator.slidesadventuremod.item.FrigidiumItem;
import net.mcreator.slidesadventuremod.item.EnchantedSwordItem;
import net.mcreator.slidesadventuremod.SlidesAdventureModMod;

public class SlidesAdventureModModItems {
	public static final DeferredRegister<Item> REGISTRY = DeferredRegister.create(ForgeRegistries.ITEMS, SlidesAdventureModMod.MODID);
	public static final RegistryObject<Item> RUSTY_IRON_ARMOR_HELMET = REGISTRY.register("rusty_iron_armor_helmet",
			() -> new RustyIronArmorItem.Helmet());
	public static final RegistryObject<Item> RUSTY_IRON_ARMOR_CHESTPLATE = REGISTRY.register("rusty_iron_armor_chestplate",
			() -> new RustyIronArmorItem.Chestplate());
	public static final RegistryObject<Item> RUSTY_IRON_ARMOR_LEGGINGS = REGISTRY.register("rusty_iron_armor_leggings",
			() -> new RustyIronArmorItem.Leggings());
	public static final RegistryObject<Item> RUSTY_IRON_ARMOR_BOOTS = REGISTRY.register("rusty_iron_armor_boots",
			() -> new RustyIronArmorItem.Boots());
	public static final RegistryObject<Item> LEAF_FLOOR = block(SlidesAdventureModModBlocks.LEAF_FLOOR, CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> FRIGIDIUM = REGISTRY.register("frigidium", () -> new FrigidiumItem());
	public static final RegistryObject<Item> FRIGIDIUM_ORE = block(SlidesAdventureModModBlocks.FRIGIDIUM_ORE, CreativeModeTab.TAB_BUILDING_BLOCKS);
	public static final RegistryObject<Item> FRIGIDIUM_BLOCK = block(SlidesAdventureModModBlocks.FRIGIDIUM_BLOCK,
			CreativeModeTab.TAB_BUILDING_BLOCKS);
	public static final RegistryObject<Item> FRIGIDSTEEL = REGISTRY.register("frigidsteel", () -> new FrigidsteelItem());
	public static final RegistryObject<Item> FRIGID_LIGHT = block(SlidesAdventureModModBlocks.FRIGID_LIGHT, CreativeModeTab.TAB_BUILDING_BLOCKS);
	public static final RegistryObject<Item> PRICKLY_PEAR_CACTUS = REGISTRY.register("prickly_pear_cactus", () -> new PricklyPearCactusItem());
	public static final RegistryObject<Item> PRICKLY_PEAR_STAGE_1 = block(SlidesAdventureModModBlocks.PRICKLY_PEAR_STAGE_1,
			CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> PRICKLY_PEAR_SEED = REGISTRY.register("prickly_pear_seed", () -> new PricklyPearSeedItem());
	public static final RegistryObject<Item> PRICKLY_PEAR_STAGE_2 = block(SlidesAdventureModModBlocks.PRICKLY_PEAR_STAGE_2,
			CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> PRICKLY_PEAR_STAGE_3 = block(SlidesAdventureModModBlocks.PRICKLY_PEAR_STAGE_3,
			CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> PRICKLY_PEAR_FRUIT_PLANT = block(SlidesAdventureModModBlocks.PRICKLY_PEAR_FRUIT_PLANT,
			CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> PRICKLY_PEAR = REGISTRY.register("prickly_pear", () -> new PricklyPearItem());
	public static final RegistryObject<Item> ENCHANTED_SWORD = REGISTRY.register("enchanted_sword", () -> new EnchantedSwordItem());
	public static final RegistryObject<Item> OBSIDIAN_SWORD = REGISTRY.register("obsidian_sword", () -> new ObsidianSwordItem());
	public static final RegistryObject<Item> LILYTURF = block(SlidesAdventureModModBlocks.LILYTURF, CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> AUBRIETA = block(SlidesAdventureModModBlocks.AUBRIETA, CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> CRACKED_STONE = block(SlidesAdventureModModBlocks.CRACKED_STONE, CreativeModeTab.TAB_BUILDING_BLOCKS);
	public static final RegistryObject<Item> MARIGOLD = block(SlidesAdventureModModBlocks.MARIGOLD, CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> SQUAT_CACTUS = block(SlidesAdventureModModBlocks.SQUAT_CACTUS, CreativeModeTab.TAB_DECORATIONS);
	public static final RegistryObject<Item> WILD_POTATO = block(SlidesAdventureModModBlocks.WILD_POTATO, CreativeModeTab.TAB_DECORATIONS);

	private static RegistryObject<Item> block(RegistryObject<Block> block, CreativeModeTab tab) {
		return REGISTRY.register(block.getId().getPath(), () -> new BlockItem(block.get(), new Item.Properties().tab(tab)));
	}
}
