
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.slidesadventuremod.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ColorHandlerEvent;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.level.block.Block;

import net.mcreator.slidesadventuremod.block.WildPotatoBlock;
import net.mcreator.slidesadventuremod.block.SquatCactusBlock;
import net.mcreator.slidesadventuremod.block.PricklyPearStage3Block;
import net.mcreator.slidesadventuremod.block.PricklyPearStage2Block;
import net.mcreator.slidesadventuremod.block.PricklyPearStage1Block;
import net.mcreator.slidesadventuremod.block.PricklyPearFruitPlantBlock;
import net.mcreator.slidesadventuremod.block.MarigoldBlock;
import net.mcreator.slidesadventuremod.block.LilyturfBlock;
import net.mcreator.slidesadventuremod.block.LeafFloorBlock;
import net.mcreator.slidesadventuremod.block.FrigidiumOreBlock;
import net.mcreator.slidesadventuremod.block.FrigidiumBlockBlock;
import net.mcreator.slidesadventuremod.block.FrigidLightBlock;
import net.mcreator.slidesadventuremod.block.CrackedStoneBlock;
import net.mcreator.slidesadventuremod.block.AubrietaBlock;
import net.mcreator.slidesadventuremod.SlidesAdventureModMod;

public class SlidesAdventureModModBlocks {
	public static final DeferredRegister<Block> REGISTRY = DeferredRegister.create(ForgeRegistries.BLOCKS, SlidesAdventureModMod.MODID);
	public static final RegistryObject<Block> LEAF_FLOOR = REGISTRY.register("leaf_floor", () -> new LeafFloorBlock());
	public static final RegistryObject<Block> FRIGIDIUM_ORE = REGISTRY.register("frigidium_ore", () -> new FrigidiumOreBlock());
	public static final RegistryObject<Block> FRIGIDIUM_BLOCK = REGISTRY.register("frigidium_block", () -> new FrigidiumBlockBlock());
	public static final RegistryObject<Block> FRIGID_LIGHT = REGISTRY.register("frigid_light", () -> new FrigidLightBlock());
	public static final RegistryObject<Block> PRICKLY_PEAR_STAGE_1 = REGISTRY.register("prickly_pear_stage_1", () -> new PricklyPearStage1Block());
	public static final RegistryObject<Block> PRICKLY_PEAR_STAGE_2 = REGISTRY.register("prickly_pear_stage_2", () -> new PricklyPearStage2Block());
	public static final RegistryObject<Block> PRICKLY_PEAR_STAGE_3 = REGISTRY.register("prickly_pear_stage_3", () -> new PricklyPearStage3Block());
	public static final RegistryObject<Block> PRICKLY_PEAR_FRUIT_PLANT = REGISTRY.register("prickly_pear_fruit_plant",
			() -> new PricklyPearFruitPlantBlock());
	public static final RegistryObject<Block> LILYTURF = REGISTRY.register("lilyturf", () -> new LilyturfBlock());
	public static final RegistryObject<Block> AUBRIETA = REGISTRY.register("aubrieta", () -> new AubrietaBlock());
	public static final RegistryObject<Block> CRACKED_STONE = REGISTRY.register("cracked_stone", () -> new CrackedStoneBlock());
	public static final RegistryObject<Block> MARIGOLD = REGISTRY.register("marigold", () -> new MarigoldBlock());
	public static final RegistryObject<Block> SQUAT_CACTUS = REGISTRY.register("squat_cactus", () -> new SquatCactusBlock());
	public static final RegistryObject<Block> WILD_POTATO = REGISTRY.register("wild_potato", () -> new WildPotatoBlock());

	@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD, value = Dist.CLIENT)
	public static class ClientSideHandler {
		@SubscribeEvent
		public static void clientSetup(FMLClientSetupEvent event) {
			LeafFloorBlock.registerRenderLayer();
			PricklyPearStage1Block.registerRenderLayer();
			PricklyPearStage2Block.registerRenderLayer();
			PricklyPearStage3Block.registerRenderLayer();
			PricklyPearFruitPlantBlock.registerRenderLayer();
			LilyturfBlock.registerRenderLayer();
			AubrietaBlock.registerRenderLayer();
			MarigoldBlock.registerRenderLayer();
			SquatCactusBlock.registerRenderLayer();
			WildPotatoBlock.registerRenderLayer();
		}

		@SubscribeEvent
		public static void blockColorLoad(ColorHandlerEvent.Block event) {
			LeafFloorBlock.blockColorLoad(event);
		}

		@SubscribeEvent
		public static void itemColorLoad(ColorHandlerEvent.Item event) {
			LeafFloorBlock.itemColorLoad(event);
		}
	}
}
